#include <iostream>
#include <vector>
#include <stdlib.h>
#include <iomanip>

using namespace std;
typedef vector<double> dvec;

double find_max1(dvec vec)
{
    if(vec.size() == 0) return 0;
    if(vec.size() == 1) return vec[0];

    dvec v1, v2;
    unsigned i = 0;
    while(i < vec.size() / 2) v1.push_back(vec[i++]);
    while(i < vec.size()    ) v2.push_back(vec[i++]);

    double m1 = find_max1(v1), m2 = find_max1(v2);
    if(m1 > m2) return m1;
    return m2;
}

double find_max2(dvec vec)
{
    if(vec.size() == 0) return 0;
    if(vec.size() == 1) return vec[0];

    dvec v1, v2;
    for(auto x : vec)
    {
        if(v1.size() > v2.size())
            v2.push_back(x);
        else
            v1.push_back(x);
    }

    double m1 = find_max2(v1), m2 = find_max2(v2);
    if(m1 > m2) return m1;
    return m2;
}

double find_max3(dvec vec)
{
    if(vec.size() == 0) return 0;
    if(vec.size() == 1) return vec[0];

    dvec v1(vec.begin(), vec.begin() + vec.size() / 2);
    dvec v2(vec.begin() + vec.size() / 2,   vec.end());

    double m1 = find_max3(v1), m2 = find_max3(v2);
    if(m1 > m2) return m1;
    return m2;
}

int main(void)
{
    dvec my_vector;
    for(int i = 0; i < 100; ++i)
        my_vector.push_back(20.0 * rand() / RAND_MAX - 10.0);

    for(auto x : my_vector)
        cout << fixed << setprecision(4) << setw(10) << x;

    cout << endl << endl;

    cout << "find_max1: " << find_max1(my_vector) << endl;
    cout << "find_max2: " << find_max2(my_vector) << endl;
    cout << "find_max3: " << find_max3(my_vector) << endl;
    return 0;
}
